# -*- coding: iso-8859-15 -*-
"""PAM_constants.py

(Autogenerated) file which contains all constants necessary for the PAM
binding.

Copyright (C) 2005, Heiko Wundram.
Released under a BSD-style license, see LICENSE for details.
"""

# Versioning.
__author__ = "$LastChangedBy: modelnine $"
__version__ = "$LastChangedRevision: 104 $"
__date__ = "$LastChangedDate: 2005-10-28 19:59:51 +0200 (pią, 28 paź 2005) $"

# Python imports.

import os
import re
import sys

# Defines.

SPLIT_RE = "[^a-zA-Z0-9\(\)\<\>_]+"

# Function which imports PAM constants from headers.

def _declareConstants():
    basedir = "/usr/include/security"
    files = os.listdir(basedir)
    constants = file(sys.argv[0],"r+")
    pos = 0

    # Find file position for starting items.
    while True:
        line = constants.readline()
        if not line:
            raise ValueError, "Invalid source file."

        pos += len(line)
        if line == "# --- CODE END ---\n":
            break

    # Go there.
    constants.seek(pos)

    # Start appending declarations from PAM headers.
    for f in files:
        # Make sure we can actually read file, if not, just continue.
        try:
            incfile = open(os.path.join(basedir,f),"r")
        except:
            continue

        # Read lines, find ones which start with "#define", and extract
        # data.
        for line in incfile:
            # Remove Preprocessor signature.
            line = line.lstrip()
            if not line.startswith("#"):
                continue

            # Split command and rest.
            try:
                command, rest = re.split(SPLIT_RE,line[1:],1)
                if command <> "define":
                    continue
            except:
                # Couldn't split off rest.
                continue

            # Try to split off name and value.
            try:
                name, value, comment = re.split(SPLIT_RE,rest,2)
            except:
                try:
                    name, value = re.split(SPLIT_RE,rest,1)
                except:
                    continue

            # Check name.
            if not name.startswith("PAM_"):
                continue
            name = name[4:]

            # Check value.
            try:
                # Dirty hack to get values such as 0x2000U (unsigned...)
                if value.endswith("U"):
                    value = value[:-1]
                print "%s = %s" % (name,value)
                value = eval(value)
            except:
                continue

            # Write out to incfile.
            constants.write("%s = %r\n" % (name,value))

    # Truncate incfile.
    constants.truncate()

# Call function when declaring constants.
if __name__ == "__main__":
    _declareConstants()

# NO PERSONAL CHANGES BEHIND THIS POINT!
# --- CODE END ---
AUTHTOK = 6
OLDAUTHTOK = 7
PRELIM_CHECK = 16384
UPDATE_AUTHTOK = 8192
DATA_REPLACE = 536870912
BP_MAX_LENGTH = 131072
BPC_FALSE = 0
BPC_TRUE = 1
BPC_OK = 1
BPC_SELECT = 2
BPC_DONE = 3
BPC_FAIL = 4
BPC_GETENV = 65
BPC_PUTENV = 66
BPC_TEXT = 67
BPC_ERROR = 68
BPC_PROMPT = 69
BPC_PASS = 70
SUCCESS = 0
OPEN_ERR = 1
SYMBOL_ERR = 2
SERVICE_ERR = 3
SYSTEM_ERR = 4
BUF_ERR = 5
PERM_DENIED = 6
AUTH_ERR = 7
CRED_INSUFFICIENT = 8
AUTHINFO_UNAVAIL = 9
USER_UNKNOWN = 10
MAXTRIES = 11
NEW_AUTHTOK_REQD = 12
ACCT_EXPIRED = 13
SESSION_ERR = 14
CRED_UNAVAIL = 15
CRED_EXPIRED = 16
CRED_ERR = 17
NO_MODULE_DATA = 18
CONV_ERR = 19
AUTHTOK_ERR = 20
AUTHTOK_RECOVER_ERR = 21
AUTHTOK_LOCK_BUSY = 22
AUTHTOK_DISABLE_AGING = 23
TRY_AGAIN = 24
IGNORE = 25
ABORT = 26
AUTHTOK_EXPIRED = 27
MODULE_UNKNOWN = 28
BAD_ITEM = 29
CONV_AGAIN = 30
INCOMPLETE = 31
SILENT = 32768
DISALLOW_NULL_AUTHTOK = 1
ESTABLISH_CRED = 2
DELETE_CRED = 4
REINITIALIZE_CRED = 8
REFRESH_CRED = 16
CHANGE_EXPIRED_AUTHTOK = 32
SERVICE = 1
USER = 2
TTY = 3
RHOST = 4
CONV = 5
RUSER = 8
USER_PROMPT = 9
FAIL_DELAY = 10
DATA_SILENT = 1073741824
PROMPT_ECHO_OFF = 1
PROMPT_ECHO_ON = 2
ERROR_MSG = 3
TEXT_INFO = 4
RADIO_TYPE = 5
BINARY_PROMPT = 7
MAX_NUM_MSG = 32
MAX_MSG_SIZE = 512
MAX_RESP_SIZE = 512
