/* PyAuthD_client.c
   ----------------

   Implements the client code which connects to the Python process. This file
   implements openPyAuthD and closePyAuthD.

   Copyright (C) 2005, Heiko Wundram.
   Released under a BSD-style license, see LICENSE for details.

$LastChangedBy: modelnine $
$LastChangedRevision: 125 $
$LastChangedDate: 2005-10-29 15:31:42 +0200 (sob, 29 paź 2005) $
*/

#include <malloc.h>
#include <stdlib.h>
#include <string.h>
#include <sys/socket.h>
#include <sys/types.h>
#include <sys/un.h>
#include <syslog.h>
#include <unistd.h>

/* Load specifications for PyAuthD. */

#include "PyAuthD_client.h"

int openPyAuthD(int remotetype)
{
  int sock, remote_len;
  struct sockaddr_un remote;

  if( ( sock = socket(AF_UNIX,SOCK_STREAM,0) ) == -1 )
    goto SOCKET_ERROR;

  remote.sun_family = AF_UNIX;
  strcpy(remote.sun_path,AUTHD_SOCK_PATH);
  remote_len = sizeof(remote.sun_family) + strlen(remote.sun_path);
  if( connect(sock,(struct sockaddr*)&remote,remote_len) == -1 )
    goto SOCKET_ERROR;

  SEND_VALUE(remotetype);

  return sock;

 SOCKET_ERROR:
  syslog(LOG_AUTHPRIV|LOG_CRIT,"Unable to open PyAuthD socket.");
  if( sock != -1 )
    close(sock);
  return -1;

 SEND_ERROR:
  syslog(LOG_AUTHPRIV|LOG_CRIT,"Unable to send PyAuthD remote ident.");
  close(sock);
  return -1;
}

void closePyAuthD(int sock)
{
  if( sock != -1 )
    close(sock);
}
